import es
import playerlib
import popuplib
import gamethread
from JoeyCMDs import JoeyCMDs

est = JoeyCMDs("est")

time_check = es.ServerVar("time_check", 15, "check every x seconds for an afk player")
server_deathmatch = es.ServerVar("server_deathmatch", 0, "0= regular server 1=deathmatch or respawn")

vector_saver = {}

info = es.AddonInfo()
info.name     = "Advanced AFK"
info.version  = "2.0"
info.url      = "http://addons.eventscripts.com/addons/view/"
info.basename = "adv_afk"
info.author   = "Juba_PornBorn"

def load():
    global warning_afk # afk menu
    vector_saver.clear() # Clear all player info
    # Make public
    es.ServerVar(info.basename, info.version).makepublic()
    # Announce load
    es.dbgmsg(0,"[Advanced AFK] Loaded")
    # Create the menu:
    warning_afk = popuplib.easymenu('warning_afk', '_popup_choice', afk_menuselect)
    warning_afk.settitle("...You are afk frozen...")
    afks = ('Get back in game now!', 'Go Spectator')
    for options in afks: 
        warning_afk.addoption(options, options)
    #create the repeat
    gamethread.delayedname(time_check, 'loops', loop)

def loop():
    check_all()   
    # another way
    # for player in filter((lambda x: not es.getplayerprop(x, 'CBasePlayer.pl.deadflag') and not es.getplayersteamid( x ) == "BOT"), es.getUseridList()):
        # check_all(player)
    #repeats loops
    gamethread.delayedname(time_check, 'loops', loop)
 
def unload():
    try:
        popuplib.delete('warning_afk')
    except ValueError:
        es.dbgmsg(0, "warning_afk does not exist...")
	
	es.dbgmsg(0,"[Advanced AFK] Unloaded")
    
def es_map_start(event_var): 
    vector_saver.clear() # Clear all player info

def check_all():
    for player in playerlib.getPlayerList("#alive,#human"): 
        #check player existence in keygroup
        if vector_saver.has_key(int(player)):
            if len(vector_saver[int(player)]) == 2:
                #get player position and view
                pos = es.getplayerlocation(int(player))
                vector_view = player.get('x')
                
                if vector_view == vector_saver[int(player)]['vector_check'] and pos == vector_saver[int(player)]['position']:
                    if player.get('c4') == 1:
                        es.sexec(int(player), 'kill')
                    else:
                        popuplib.send('warning_afk', player)
                        es.setplayerprop(int(player), "CBasePlayer.m_fFlags", 32)
                        est.god(int(player), 1)
                        est.setplayercolor(int(player), 0, 0, 0, 0, 1)
                        #set a value for player_spawn
                        vector_saver[int(player)]["team"] = player.get('teamid')
                else:
                    vector_saver[int(player)] = {'vector_check':player.get('x'), 'position':es.getplayerlocation(int(player))}
            #calculate players ingame and afk players
            if server_deathmatch == 0:
                if len(vector_saver[int(player)]) == 3:
                    if es.getlivingplayercount(2) == len(filter(lambda x: vector_saver[x]["team"] == 2, vector_saver)):
                        for t in playerlib.getPlayerList('#t'):
                            es.sexec(int(t), 'kill')
                    if es.getlivingplayercount(3) == len(filter(lambda x: vector_saver[x]["team"] == 3, vector_saver)):
                        for ct in playerlib.getPlayerList('#ct'):
                            es.sexec(int(ct), 'kill')
        else:
            vector_saver[int(player)] = {'vector_check':player.get('x'), 'position':es.getplayerlocation(int(player))}

def afk_menuselect(userid, choice, popupid):
    global user
    user = userid
    if choice == 'Get back in game now!':
        est.setplayercolor(userid, 255, 255, 255, 255, 1)
        es.emitsound("player", int(userid), "ambient/tones/elev4.wav", "1.0", "0.3")
        gamethread.delayedname(5, 'delays', delayer)
        del vector_saver[int(userid)]
        
    if choice == 'Go Spectator':
        es.changeteam(int(userid),'1')
        es.setplayerprop(user, "CBasePlayer.m_fFlags", 0)
        del vector_saver[int(userid)]
        
def delayer():
    est.god(int(user), 0) 
    es.setplayerprop(user, "CBasePlayer.m_fFlags", 0) 
    es.tell(user, '#multi', '#green You are now unfrozed!')
     
def player_spawn(event_var):
    player = event_var['userid']
    if vector_saver.has_key(int(player)):
        if len(vector_saver[int(player)]) == 3:
            es.setplayerprop(player, "CBasePlayer.m_fFlags", 32)
            est.god(int(player), 1)
            est.setplayercolor(int(player), 0, 0, 0, 0, 1)
     
def player_disconnect(event_var):
    player = event_var['userid']
    if vector_saver.has_key(int(player)):
        del vector_saver[int(player)]
        